(in-package :om)

;------------------------------------------CHANGECHAN--------------------------------------
;;Karim Haddad utils. (2000) repmus Ircam


(om::defmethod! changechan ((self poly) (chan list) &optional (n '(0)))
   
   :initvals '(t '(1 2) '(0)) 
   :indoc '("self" "chan" "n")
   :icon 147
   :doc  "Changes midi channels in a voice or poly object. If it is a poly object
you can specify which voice will be changed by openning the optional input <n>.
Further more, in voice method, if list inputed, it will change all notes according to the list."
   (let* ((newself (clone self))
          (tempo (qtempo self)))
     
     (progn
       (mapcar #'(lambda (nth-voices channels) 
                   (setf (nth nth-voices (inside newself))
                   (changechan (nth nth-voices (inside newself)) channels))
                   )
               n chan)
       (tempochg newself tempo)   ;This is for the time being, in order to corret tempo
       newself
       )))


(om::defmethod! changechan ((self voice)
                               (chan number)
                               &optional (n '(0)))
   (let* ((newself (clone self))
          (tempo (qtempo self)))
     (progn 
       (mapcar #'(lambda (x) (changechan x chan))
          (inside newself))
       (tempochg newself tempo)   ;This is for the time being, in order to corret tempo
       newself)))



(om::defmethod! changechan ((self voice)
                            (chan list)
                            &optional (n '(0)))

                (let* ((tree (tree self))
                       (tempo (qtempo self))
                       (notes (lmidic (objfromobjs self 
                                                   (make-instance 'chord-seq))))
                       (lgt (mapcar 'length notes))
                       (channels (loop for i in chan
                                       for g in lgt
                                       collect (repeat-n i g)))
                       (chrdseq (make-instance 'chord-seq
                                               :lmidic notes
                                               :lchan channels))
                       (newchrds (inside chrdseq)))
                  (make-instance 'voice
                                 :tree tree
                                 :tempo tempo
                                 :chords newchrds)))


(om::defmethod! changechan ((self om::measure)
                               (chan number)
                               &optional (n '(0)))
  (mapcar #'(lambda (x) (changechan x chan))
          (inside self)))


(om::defmethod! changechan ((self om::chord) 
                               (chan number)
                               &optional (n '(0))) 
  (mapcar #'(lambda (x) (changechan x chan))
          (inside self)))



(om::defmethod! changechan ((self om::multi-seq) (chan list) &optional (n '(0)))

     
       (mapcar #'(lambda (nth-voices channels) 
                   (setf (nth nth-voices (inside self))
                   (changechan (nth nth-voices (inside self)) channels))
                   )
               n chan))



(om::defmethod! changechan ((self om::chord-seq) 
                               (chan number)
                               &optional (n '(0))) 
  (mapcar #'(lambda (x) (changechan x chan))
          (inside self)))

(om::defmethod! changechan ((self om::chord-seq) 
                               (chan list)
                               &optional (n '(0))) 
(let* ((clone (clone self))
       (objs (inside clone)))
(loop for i in chan
      for ob in objs
      do (changechan ob i))
clone))



(om::defmethod! changechan ((self rest) 
                               (chan number)
                               &optional (n '(0))) 
  ())

(om::defmethod! changechan ((self group)
                               (chan number)
                               &optional (n '(0))) 
  (mapcar #'(lambda (x) (changechan x chan))
          (inside self)))


(om::defmethod! changechan ((self continuation-chord)
                               (chan number)
                               &optional (n '(0))) 
  (mapcar #'(lambda (x) (changechan x chan))
          (inside self)))



(om::defmethod! changechan ((self om::note) 
                               (chan number)
                               &optional (n '(0))) 
  (setf (chan self) chan))
;;;;;;;;



;-------------------------------------------------------------------------------
;------------------------------tempochg-----------------------------------------
;-------------------------------------------------------------------------------




(om::defmethod! tempochg ((self poly) (newtempo number))
   (progn (setf (qtempo self) newtempo)
   (mapcar #'(lambda (x) (tempochg x newtempo))
          (inside self))))

(om::defmethod! tempochg ((self voice) (newtempo number))
(progn (setf (qtempo self) newtempo)
   (mapcar #'(lambda (x) (tempochg x newtempo))
          (inside self))))

(om::defmethod! tempochg ((self chord-seq)(newtempo number))
(progn (setf (qtempo self) newtempo)
   (mapcar #'(lambda (x) (tempochg x newtempo))
          (inside self))))

(om::defmethod! tempochg ((self measure) (newtempo number))
(progn (setf (qtempo self) newtempo)
   (mapcar #'(lambda (x) (tempochg x newtempo))
          (inside self))))

(om::defmethod! tempochg ((self chord) (newtempo number))
(progn (setf (qtempo self) newtempo)
   (mapcar #'(lambda (x) (tempochg x newtempo))
          (inside self))))

(om::defmethod! tempochg ((self group) (newtempo number))
(progn (setf (qtempo self) newtempo)
   (mapcar #'(lambda (x) (tempochg x newtempo))
          (inside self))))

(om::defmethod! tempochg ((self continuation-chord) (newtempo number))
(progn (setf (qtempo self) newtempo)
   (mapcar #'(lambda (x) (tempochg x newtempo))
          (inside self))))

(om::defmethod! tempochg ((self rest) (newtempo number))
(setf (qtempo self) newtempo))

(om::defmethod! tempochg ((self note) (newtempo number))
(setf (qtempo self) newtempo))











(defmethod* set-obj-port ((self note) (port number))
""
            (setf (port self) port))

(defmethod* set-obj-port ((self chord) (port number))
            (loop for i in (inside self)
                  do (set-obj-port i port)))


(defmethod* set-obj-port ((self chord-seq) (port number))
            (loop for i in (inside self)
                  do (set-obj-port i port)))

(defmethod* set-obj-port ((self multi-seq) (port list))
            (loop for i in (inside self)
                  for prt in port
                  do (set-obj-port i prt)))

;;;;;;;;;;;;;;;;;;;;;;;;;for VOICE;;;;;;;;;;;;;;;;;;;;;;;;;
(defmethod* set-obj-port ((self rest) (port number))
nil)

(defmethod* set-obj-port ((self continuation-chord) (port number))
            (loop for i in (inside self)
                  do (set-obj-port i port)))


(defmethod* set-obj-port ((self group) (port number))
            (loop for i in (inside self)
                  do (set-obj-port i port)))

(defmethod* set-obj-port ((self measure) (port number))
            (loop for i in (inside self)
                  do (set-obj-port i port)))

(defmethod* set-obj-port ((self voice) (port number))
            (loop for i in (inside self)
                  do (set-obj-port i port)))


(defmethod* set-obj-port ((self poly) (port list))
            (loop for i in (inside self)
                  for prt in port
                  do (set-obj-port i prt)))
